"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Stream = void 0;
const abort_controller_1 = __importDefault(require("abort-controller"));
const node_fetch_1 = __importDefault(require("node-fetch"));
const ndjson_1 = __importDefault(require("ndjson"));
;
class Stream {
    constructor(baseUrl) {
        this.baseUrl = baseUrl;
    }
    ndjson(url, opts = {}) {
        let controller = new abort_controller_1.default();
        const abort = () => {
            controller.abort();
        };
        let { headers, ...rest } = opts;
        return node_fetch_1.default(this.baseUrl + url, {
            signal: controller.signal,
            headers: {
                ...headers
            },
            ...rest
        }).then(response => {
            if (!response.ok) {
                throw response.statusText;
            }
            return {
                abort,
                response: response.body.pipe(ndjson_1.default.parse())
            };
        });
    }
    form(data) {
        const form = new FormData();
        for (let key in data) {
            form.append(key, data[key]);
        }
        return form;
    }
}
exports.Stream = Stream;
//# sourceMappingURL=stream.js.map