"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Xhr = exports.xhrHeader = exports.defaultInit = void 0;
const node_fetch_1 = __importDefault(require("node-fetch"));
const form_data_1 = __importDefault(require("form-data"));
;
exports.defaultInit = {
    cache: 'no-cache',
    credentials: 'same-origin'
};
exports.xhrHeader = {
    'X-Requested-With': 'XMLHttpRequest'
};
class Xhr {
    constructor(baseUrl) {
        this.baseUrl = baseUrl;
    }
    text(url, init = {}) {
        return this.raw(url, init).then(res => {
            if (res.ok)
                return res.text();
            return res.text()
                .then((_) => { throw _; });
        });
    }
    json(url, init = {}) {
        return this.raw(url, init).then(res => {
            if (res.ok)
                return res.json();
            return res.json()
                .then((_) => { throw _; });
        });
    }
    raw(url, init = {}) {
        let { headers, ...rest } = init;
        return node_fetch_1.default(this.baseUrl + url, {
            ...exports.defaultInit,
            headers: {
                ...exports.xhrHeader,
                ...headers
            },
            ...rest
        });
    }
    form(data) {
        const form = new form_data_1.default();
        for (let key in data) {
            form.append(key, data[key]);
        }
        return form;
    }
    headers(url) {
        return node_fetch_1.default(this.baseUrl + url, {
            redirect: 'manual'
        })
            .then(_ => {
            return _.headers.raw();
        });
    }
}
exports.Xhr = Xhr;
//# sourceMappingURL=xhr.js.map